/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <nostalgia/core/gfx.hpp>

#include "context.hpp"

namespace nostalgia::core {

GbaContext::GbaContext(turbine::Context *tctx) noexcept: turbineCtx(tctx) {
}

ox::Error initGfx(Context *ctx, InitParams const&) noexcept;

ox::Result<ox::UniquePtr<Context>> init(turbine::Context *tctx, InitParams const&params) noexcept {
	auto ctx = ox::make_unique<GbaContext>(tctx);
	oxReturnError(initGfx(ctx.get(), params));
	return ox::UPtr<Context>(ctx.release());
}

}