/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include "context.hpp"
#include "gfx.hpp"

namespace nostalgia::core {

GlContext::GlContext(turbine::Context &tctx) noexcept:
	turbineCtx(tctx),
	drawer(*this) {
}

GlContext::~GlContext() noexcept {
	shutdownGfx(*this);
}

ox::Result<ox::UniquePtr<Context>> init(turbine::Context *tctx, InitParams const&params) noexcept {
	auto ctx = ox::make_unique<GlContext>(*tctx);
	oxReturnError(initGfx(ctx.get(), params));
	return ox::UPtr<Context>(ctx.release());
}

}
