
#include <ox/std/size.hpp>
#include <ox/std/vector.hpp>

#include <nostalgia/core/ptidxconv.hpp>

namespace nostalgia::core {

ox::Vector<uint32_t> resizeTileSheetData(
		ox::Vector<uint32_t> const&srcPixels,
		ox::Size const&srcSize,
		int scale = 2) noexcept {
	ox::Vector<uint32_t> dst;
	auto dstWidth = srcSize.width * scale;
	auto dstHeight = srcSize.height * scale;
	const auto pixelCnt = dstWidth * dstHeight;
	dst.resize(static_cast<std::size_t>(pixelCnt));
	for (auto i = 0; i < pixelCnt; ++i) {
		const auto dstPt = idxToPt(i, 1, scale);
		const auto srcPt = dstPt / ox::Point{scale, scale};
		const auto srcIdx = ptToIdx(srcPt, 1);
		const auto srcPixel = srcPixels[srcIdx];
		dst[static_cast<std::size_t>(i)] = srcPixel;
	}
	return dst;
}

}
