/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include "scenestatic.hpp"

namespace nostalgia::scene {

class Scene {
	private:
		const SceneStatic &m_sceneStatic;

	public:
		explicit Scene(const SceneStatic &sceneStatic) noexcept;

		ox::Error setupDisplay(core::Context *ctx) const noexcept;

	private:
		void setupLayer(core::Context*, const ox::Vector<uint16_t> &layer, unsigned layerNo) const noexcept;

};

}
