/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <nostalgia/core/gfx.hpp>

#include "sceneeditorview.hpp"

namespace nostalgia::scene {

SceneEditorView::SceneEditorView(turbine::Context *tctx, const SceneStatic &sceneStatic):
	m_sceneStatic(sceneStatic),
	m_scene(m_sceneStatic) {
	oxThrowError(core::init(tctx, {.glInstallDrawer = false}).moveTo(&m_cctx));
}

ox::Error SceneEditorView::setupScene() noexcept {
	return m_scene.setupDisplay(m_cctx.get());
}

void SceneEditorView::draw(int width, int height) noexcept {
	if (width != m_frameBuffer.width || height != m_frameBuffer.height) {
		glutils::resizeInitFrameBuffer(&m_frameBuffer, width, height);
	}
	const glutils::FrameBufferBind frameBufferBind(m_frameBuffer);
	core::gl::drawMainView(m_cctx.get(), {width, height});
}

const glutils::FrameBuffer &SceneEditorView::framebuffer() const noexcept {
	return m_frameBuffer;
}

}
