/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <glutils/glutils.hpp>

#include <nostalgia/core/context.hpp>
#include <nostalgia/scene/scene.hpp>

namespace nostalgia::scene {

class SceneEditorView {

	private:
		ox::UPtr<core::Context> m_cctx;
		const SceneStatic &m_sceneStatic;
		Scene m_scene;
		glutils::FrameBuffer m_frameBuffer;

	public:
		SceneEditorView(turbine::Context *ctx, const SceneStatic &sceneStatic);

		ox::Error setupScene() noexcept;

		void draw(int width, int height) noexcept;

		[[nodiscard]]
		const glutils::FrameBuffer &framebuffer() const noexcept;

};

}
