/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <studio/studio.hpp>

#include "sceneeditor-imgui.hpp"

namespace nostalgia::scene {

class StudioModule: public studio::Module {
	public:
		ox::Vector<studio::EditorMaker> editors(turbine::Context *ctx) const noexcept override;
		ox::Vector<ox::UPtr<studio::ItemMaker>> itemMakers(turbine::Context*) const noexcept override;
};

ox::Vector<studio::EditorMaker> StudioModule::editors(turbine::Context *ctx) const noexcept {
	return {
		{
			{"nscn"},
			[ctx](ox::CRStringView path) -> ox::Result<studio::BaseEditor*> {
				return ox::makeCatch<SceneEditorImGui>(ctx, path);
			}
		},
	};
}

ox::Vector<ox::UPtr<studio::ItemMaker>> StudioModule::itemMakers(turbine::Context*) const noexcept {
	ox::Vector<ox::UPtr<studio::ItemMaker>> out;
	return out;
}

static StudioModule mod;
const studio::Module *studioModule() noexcept {
	return &mod;
}

}
