/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <turbine/turbine.hpp>

namespace turbine {

struct GlfwContext: public turbine::Context {
	int uninterruptedRefreshes = 3;
	ox::UPtr<BaseClipboardObject> clipboard;
	struct GLFWwindow *window = nullptr;
	// sets screen refresh to constant instead of only on event
	bool constantRefresh = true;
	ox::Vector<gl::Drawer*, 5> drawers;
	int64_t startTime = 0;
	uint64_t wakeupTime = 0;
	uint64_t keysDown = 0;
	uint64_t prevFpsCheckTime = 0;
	uint64_t draws = 0;
};

}
