/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/fs/fs.hpp>

#include "clipboard.hpp"
#include "event.hpp"
#include "gfx.hpp"
#include "input.hpp"

namespace turbine {

ox::Result<ox::UniquePtr<Context>> init(ox::UniquePtr<ox::FileSystem> fs, ox::CRStringView appName) noexcept;

void shutdown(Context &ctx) noexcept;

ox::Error run(Context &ctx) noexcept;

// Returns the number of milliseconds that have passed since the start of the
// program.
[[nodiscard]]
uint64_t ticksMs(const Context &ctx) noexcept;

void requestShutdown(Context &ctx) noexcept;

}
